let running = ref false

let min_delay,
    max_delay = 0.04,
                5.

let mutex = Mutex.create ()

let delay = ref (sqrt (min_delay *. max_delay))

let play () =
  while !running do
    Automaton.step ();
    View.draw ();
(*    Mutex.lock mutex;*)
    while Mutex.try_lock mutex do
      ()
    done;
    Thread.delay !delay;
    Mutex.unlock mutex;
  done

let run () =
  if not !running then(
    running := true;
    ignore (Thread.create play ());
    View.autoplay_quite := false)

let stop () = running := false; View.autoplay_quite := true

let set_speed s =
(*  Mutex.lock mutex;*)

  while Mutex.try_lock mutex do
    ()
  done;
  delay :=
    (match s with
      9 -> 0.
    | s' ->
      let mult_step = (max_delay/.min_delay) ** (1.0/.8.0) in
        max_delay /. (mult_step ** (float_of_int s')));
  Mutex.unlock mutex