open Useful

open Iv2

let empty = Iv2Set.empty

(* Iv2        Iv2Map           int            Array            Iv2Set
   cell --- cell_counts --> cell_count --- cells_by_cnt ---> set of cells
*)
let count (cell_counts, cells_by_cnt) cell =
  if Iv2Map.mem cell cell_counts then(
    let cell_count = Iv2Map.find cell cell_counts in
    let new_cell_count = succ cell_count in
      Iv2Map.add cell new_cell_count cell_counts,
      (cells_by_cnt.(cell_count) <-
        Iv2Set.remove cell cells_by_cnt.(cell_count);          
      cells_by_cnt.(new_cell_count) <-
        Iv2Set.add cell cells_by_cnt.(new_cell_count);
      cells_by_cnt)
  )else(
    Iv2Map.add cell 1 cell_counts,
    (cells_by_cnt.(1) <- Iv2Set.add cell cells_by_cnt.(1);
    cells_by_cnt)
  )

let neighbourhood =
  [-1,1;  0,1;  1,1;
   -1,0;        1,0;
   -1,-1; 0,-1; 1,-1]

let map_array_set_step world =
  let cells_by_count =
    snd
      (Iv2Set.fold
        (fun center_cell counter ->
          List.fold_left
            (fun count_acc delta ->
               count count_acc (center_cell ++ delta))
            counter
            neighbourhood)
        world
        (Iv2Map.empty, Array.make (1+8) empty)) in
    Iv2Set.union
      cells_by_count.(3)
      (Iv2Set.inter cells_by_count.(2) world)
(*
let init_test () = ignore(List.map toggle [      0,1;
                                           -1,0; 0,0; 1,0;
                                                     1,-1])
                                                     
let cnt = ref 0
*)

let step () =
(*
  incr cnt;
  if !cnt = 400 then
    exit 0;*)
  WorldHistory.change_state
    (fun _ ->
       WorldHistory.get_next ())

let limit () =
  WorldHistory.change_state
    (fun _ ->
       WorldHistory.get_state ())

let toggle cell =
  WorldHistory.change_state
    (fun world ->
      (if Iv2Set.mem cell world then
        Iv2Set.remove
       else
        Iv2Set.add) cell world)