type 'a t = { undo_list:'a list; redo_list:'a list }

let empty first = { undo_list = [first]; redo_list = [] }

let get h = List.hd h.undo_list

let get_prev h =
  match List.tl !h.undo_list with
    [] ->
      get !h
  | head::_ ->
      head

let create first = ref (empty first)

let init h first = h := (empty first)

let get_state h = get !h

let change_state h f =
  h := { undo_list = (f (get !h))::!h.undo_list; redo_list = [] }

let undo h =
  h := (match !h.undo_list with
         [] ->
           failwith "History.undo : Shouldn't happen."
       | [_] ->
         !h
       | head::tail ->
         { undo_list = tail; redo_list = head::!h.redo_list })

let redo h =
  h := (match !h.redo_list with
          [] ->
            !h
        | head::tail ->
            { undo_list = head::!h.undo_list; redo_list = tail })