let ( <<- ) f g x = f (g x)

let id x = x

let div a b =
  (if a >= 0 then
    a
  else
    a - b + 1) / b

let sqr x = x * x

let left_trim s =
  let skip = function
    ' ' | '\009' -> true
  | _ -> false in  
  let len = String.length s in
  let i = ref 0 in
    while skip (String.get s !i) do
      incr i
    done;
    String.sub s !i (len - !i)

let string_end sub s =
  let n = String.length sub in
  let d = String.length s - n in
    if d >= 0 then
      String.sub s d n = sub
    else
      false

module Couple = struct
  let couple x y = x, y

  let map f (x, y) = f x, f y

  let ext2 f (x1, y1) (x2, y2) = f x1 x2, f y1 y2
  
  let uncurry2 f (x, y) = f x y
end

module Integer = struct
  type t = int
  let compare = fun x y -> y-x
end

module IntMap = Map.Make( Integer )

module Iv2 = struct

  open Couple
  
  type t = int * int

  let compare = compare

  let zero_zero = 0, 0
  
  let (++) = ext2 (+)

  let (--) = ext2 (-)

  let norm2 (x, y) = x * x + y * y

(* let ( ** ) = map <<- ( * )    	(* scalar * vector *) *)
  let ( ** ) s (x, y) = s * x, s * y

  let div2 (x, y) s = div x s, div y s  (* vector / scalar *)

  let (//) (x, y) s = x / s, y / s

  let (<<<) (x, y) (x', y') = x < x' && y < y' (* Non total order *)
  
  let (<<<=) (x, y) (x', y') = x <= x' && y <= y' (* Non total order *)
end

module Iv2Set = Set.Make( Iv2 )

module Iv2Map = Map.Make( Iv2 )

let z s = Printf.printf "%s" s; flush stdout

