open Useful

let step = ref id

let empty = Iv2Set.empty

let history = History.create empty
let next = ref empty

let update_next () = next := !step (History.get_state history)

let init s = History.init history s; update_next ()

let clear () = init empty

let get_state () = History.get_state history
let get_next () = !next
let get_prev () = History.get_prev history

let change_state f =
  History.change_state history f;
  update_next ()

let undo () = History.undo history;
  update_next ()

let redo () = History.redo history;
  update_next ()
